import os
import json
import shutil
import csv
import sys
import _winreg
import getpass
import time
import ctypes
import hashlib
import xlwt

reload(sys)
sys.setdefaultencoding('gbk')
from openpyxl import Workbook, load_workbook

dll = ctypes.cdll.LoadLibrary('..\\SangforSearchDll.dll')

def set_style(name, height, bold=False):
    style = xlwt.XFStyle()
    font = xlwt.Font()
    font.name = name
    font.bold = bold
    font.color_index = 4
    font.height = height
    # borders= xlwt.Borders()
    # borders.left= 6
    # borders.right= 6
    # borders.top= 6
    # borders.bottom= 6
    style.font = font
    # style.borders = borders
    return style

def WriteToExcel():
    fexcel = xlwt.Workbook(encoding='gbk')
    sheet1 = fexcel.add_sheet(u'sheet1', cell_overwrite_ok=True)
    first_col = sheet1.col(0)
    first_col.width = 256 * 42
    second_col = sheet1.col(1)
    second_col.width = 256 * 60
    third_col = sheet1.col(2)
    third_col.width = 256 * 30
    fourth_col = sheet1.col(3)
    fourth_col.width = 256 * 40
    row0 = [u'MD5', u'Path', u'SignName', u'Refer']
    for i in range(0, len(row0)):
        sheet1.write(0, i, row0[i], set_style('Times New Roman', 320, True))
    f = open('..\\output\\info.txt')
    line = f.readline()
    cnt = 1
    while line != '':
        line = line.strip('\r\n')
        if line == '':
            line = f.readline()
            continue
        slist = line.split(';')
        row = []
        for ele in slist:
            row.append(ele)    
        for i in range(0, len(row)):
            sheet1.write(cnt, i, row[i], set_style('Times New Roman', 250))
        line = f.readline()
        cnt = cnt + 1
    f.close()
    fexcel.save('..\\output\\info.xls')

def GetFileMd5(filename):
    if not os.path.isfile(filename):
        return '--'
    myhash = hashlib.md5()
    if filename[0] == '\\':
        return '--'
    f = file(filename,'rb')
    while True:
        b = f.read(8096)
        if not b :
            break
        myhash.update(b)
    f.close()
    return myhash.hexdigest()

def my_print(str_value, signal=2):
    print(str_value)
    vc_str = ctypes.c_char_p(str(str_value))
    vc_str_len = ctypes.c_int(len(str(str_value)))
    vc_signal = ctypes.c_int(signal)
    dll.fnPySangforSearchDll(vc_str, vc_str_len, vc_signal)

def check_file_if_in_whitelist(str_value):
    vc_str = ctypes.c_char_p(str(str_value))
    vc_str_len = ctypes.c_int(len(str(str_value)))
    result = dll.fnPyCheckFileIfInWhiteList(vc_str, vc_str_len)
    return result;

def whitelist_init():
    dll.fnPyWhiteListInit()

def whitelist_free():
    dll.fnPyWhiteListFree()

def store(out_dict, result_file):
    with open(result_file, 'a') as f:
        f.write(json.dumps(out_dict))
        f.write('\n')

def write_normal(str, result_file):
    with open(result_file, 'a') as f:
        f.write(str)
        f.write('\n')

def cur_file_dir():
    path = sys.path[0]
    if os.path.isdir(path):
        return path
    elif os.path.isfile(path):
        return os.path.dirname(path)

def deal_key_check_files(key_value):
    my_print(key_value)
    ret = os.path.exists(key_value)
    return ret

def deal_excel():
    my_print('deal excel file...')
    wb = load_workbook(filename = 'input\\sample.xlsx')
    sheet_ranges = wb['sheet1']
    my_print(sheet_ranges['E13'].value)

def start_BrowsingHistoryView():
    cmd = 'BrowsingHistoryView.exe /scomma browser.csv'
    os.system(cmd)
    shutil.copy("browser.csv", "output")
    os.remove("browser.csv")

def deal_browser_csv():
    my_print('deal_browser_csv...')
    reader = csv.reader(file("output\\browser.csv", 'rb'))
    wb = load_workbook(filename = 'input\\sample.xlsx')
    sheet_ranges = wb['sheet1']
    url_set = set([])
    for i in range(13, len(sheet_ranges.rows)):
        url_index = 'E{0}'.format(i)
        url_set.add(sheet_ranges[url_index].value)
    response = []
    for line in reader:
        for url in url_set:
            if line[0].find(url) != -1:
                response.append({'local_url': line[0], 'af_url': url})
                my_print(line[0])
    store(response, "output\\browser_match.txt")
    return 0

def get_list_element_cnt():
    mylist = []
    f = open('flux_sample_name')
    line = f.readline()
    while line:
        my_print(line)
        mylist.append(line)
        line = f.readline()
    f.close
    fout = open('fout', 'w')
    myset = set(mylist)
    for item in myset:
        my_print("%d belong to %s" %(mylist.count(item), item))
        fout.write("%d belong to %s\n" %(mylist.count(item), item))
    fout.close()

def search_by_virustotal():
    try:
        cmd = 'SangforVT.exe -n 200 -t 3'
        os.system(cmd)
    except Exception, e:
        print("search_by_virustotal")

def start_SangforBotSignScan():
    scantype = "SmartScan"
    f2 = open('scantype')
    scantype = f2.readline()
    f2.close()
    if scantype.find("SystemScan") != -1:
        cmd = 'SangforBotScan.exe'
        os.system(cmd)
        return 1
    line = "C:\\"
    f = open('setting')
    line = f.readline()
    if line == '':
        f_default = open('default_setting')
        line = f_default.readline()
        f_default.close()
    f.close()
    slist = line.split(';')
    for ele in slist:
        print ele
        #cmd = 'SangforBotScan.exe'
        cmd = 'SangforBotScan.exe -p ' + ele
        os.system(cmd)

def store_last_result():
    if os.path.exists("..\\output\\info.txt") == True:
        shutil.copy("..\\output\\info.txt", "..\\output\\LastResult")
    if os.path.exists("..\\output\\info.xls") == True:
        shutil.copy("..\\output\\info.xls", "..\\output\\LastResult")
    if os.path.exists("..\\output\\virustotal_match.txt") == True:
        shutil.copy("..\\output\\virustotal_match.txt", "..\\output\\LastResult")
    for file in os.listdir("."):
        if file.find("format-") != -1:
            shutil.copy(file, "..\\output\\LastResult")

def clean_last_result():
    with open("..\\output\\info.txt", 'w') as f:
        f.write("")
    for file in os.listdir("."):
        if file.find("format-") != -1:
            os.remove(file)
    for file in os.listdir("..\\output"):
        if file.find("info.xls") != -1:
            os.remove("..\\output\\info.xls")
        if file.find("virustotal_match.txt") != -1:
            os.remove("..\\output\\virustotal_match.txt")
        if file.find("info_quick.txt") != -1:
            os.remove("..\\output\\info_quick.txt")

def unique_sort(path):
    try:
        vc_str = ctypes.c_char_p(str(path))
        vc_str_len = ctypes.c_int(len(str(path)))
        dll.fnUniqueSort(vc_str, vc_str_len)
    except Exception, e:
        print("unique_sort error")

if __name__ == '__main__':
    '''
    '''
    my_print("SangforBotnetForensics Start Working...")
    my_print("SangforBotnetForensics Init...")
    os.system("SangforExcelToRules.exe")
    store_last_result()
    clean_last_result()
    #  start_BrowsingHistoryView()
    #  deal_browser_csv()
    #  deal_excel()
    #  get_list_element_cnt()
    try:
        start_SangforBotSignScan()
    except Exception, e:
        my_print("VC redirect sp needed")
    current_path = os.getcwd()
    info_path = current_path + "\\..\\output\\info.txt"
    unique_sort(info_path)
    search_by_virustotal()
    try:
        WriteToExcel()
    except Exception, e:
        my_print("WriteToExcel error")
    try:
        os.system("SaasPyCurlPost.exe")
    except Exception, e:
        my_print("WriteToExcel error")
    my_print("Scan Finished!", 1)
    time.sleep(1)
    my_print("Scan Finished!", 1)
    time.sleep(1)
    my_print("Scan Finished!", 1)
